drop table soil.temp_test3;
WITH grid AS (
  SELECT 
    ROW_NUMBER() OVER () AS grid_id,
    m.geom 
  FROM (
    SELECT (
      ST_Dump(
        MAKEGRID_2D(
          ST_SetSRID(st_buffer(ST_Extent(pos),
												   GREATEST(((select max(st_x(pos)) from soil.grid_sample_csv_1_to_124_p_tes2t) - 
													    (select min(st_x(pos)) from soil.grid_sample_csv_1_to_124_p_tes2t)),
												       ((select max(st_y(pos)) from soil.grid_sample_csv_1_to_124_p_tes2t) - 
													    (select min(st_y(pos)) from soil.grid_sample_csv_1_to_124_p_tes2t)))/4
												  ),4326),50,50))
         ).geom  from soil.grid_sample_csv_1_to_124_p_tes2t
  ) m
),
--Defines the centroid of the whole grid
centroid AS (
  SELECT ST_Centroid(ST_Collect(grid.geom)) AS geometry FROM grid
), 
--Rotates around the defined centroid
rotated as(SELECT ST_Rotate(grid.geom,radians(20),(SELECT geometry FROM centroid)) as polys 
		   FROM grid
		  ),
--Selectes the polygons that are intersecting the orignal data
select_data as (select polys
			   from rotated
			   where st_intersects(ST_SetSRID((select ST_Extent(pos) from soil.grid_sample_csv_1_to_124_p_tes2t), 4326),
								   polys))
--Do the final selections and joining in some average data
select row_number () over() as r_num, 
polys,
avg(2*p_olsen_) 
	into soil.temp_test3
from select_data
left join soil.grid_sample_csv_1_to_124_p_tes2t on st_intersects(polys, pos)
group by polys;
ALTER TABLE soil.temp_test3
    OWNER to demo;